
local select=select
local setfenv=setfenv
local loadstring=loadstring
local string=string
local table=table

local function result(...)
	return select("#",...), select(1,...)
end

local function precompile(template, output_func, lua_codes)
	if lua_codes == nil then
		lua_codes = {''}
	end
	local start_tag = '<?'
	local end_tag = '?>'
	
	local start1, end1 = string.find(template, start_tag, 1, true)
	local start2 = nil
	local end2 = 0
	local cEqual = string.byte('=', 1)
	while start1 ~= nil do
		if start1 > end2 + 1 then
			table.insert(lua_codes, output_func..'('..string.format("%q", string.sub(template, end2 + 1, start1 - 1))..')')
		end
		start2, end2 = string.find(template, end_tag, end1 + 1, true)
		if start2 ~= nil then
			if string.byte(template, end1 + 1) ~= cEqual then
				table.insert(lua_codes, string.sub(template, end1 + 1, start2 - 1))
			else
				table.insert(lua_codes, output_func..'('..string.sub(template, end1 + 2, start2 - 1)..')')
			end
			start1, end1 = string.find(template, start_tag, end2 + 1, true)
		else
			-- end tag not found
			end2 = end1
			start1 = nil
			-- we could error it, but we ignore it here
		end
	end
	table.insert(lua_codes, output_func..'('..string.format("%q", string.sub(template, end2 + 1))..')')
	return 
end

local compile = function (template, E)	
	if E == nil then
		E = _G
	end
	local lua_codes = {''}
	table.insert(lua_codes, "local __jass_result__ = {''}")
	table.insert(lua_codes, "local function __jass_output__(str) table.insert(__jass_result__, str) end")
	local r, err = pcall(precompile, template, '__jass_output__', lua_codes)
	if not r then
		return r, err
	end
	table.insert(lua_codes, "return table.concat(__jass_result__)")	
	local f, err = loadstring(table.concat(lua_codes, '\n'))
	if not f then
		return f, err
	end

	return pcall(setfenv(f, E))
end

return compile

