require "sys"

local loader = {}
	
loader.load = function(path)
	if global_config:get_integer("ScriptCompiler.EnableCJass", 0) ~= 0 then
		return false, 'enable cjass'
	end
	if global_config:get_integer("ThirdPartyPlugin.EnableYDTrigger", 1) ~= 1 then
		return false, 'diable'
	end
	
	-- YDTrigger MPQ·
	local yd_trigger_mpq_path = yi.get_editor_root_dir() / "share" / "mpq" / "YDTrigger.mpq"
	if not fs.exists(yd_trigger_mpq_path) or not yi.native_open_archive(yd_trigger_mpq_path, 15) then
		return false, 'cannot ' .. yd_trigger_mpq_path:filename():string()
	end
				
	loader.dll = sys.load_library_by_path(path)
	return loader.dll ~= nil
end

loader.unload = function()
	if loader.dll then
		sys.unload_library(loader.dll)
		loader.dll = nil
	end
end

return loader
