-- һЩ
require "sys"
require "bit"
require "lfs"
require "std"
require "ex"
require "ydwelua"
require "titan_engine"


-- öԻ
local function launch_config()
	local config_program = yi.get_editor_root_dir() / "bin" / "YDWEConfig.exe"
	local command_line = string.format('"%s"', config_program:string())
	sys.shell_execute(command_line)
end

-- ħ
local function launch_warcraft3()
	local config_program = yi.get_editor_root_dir() / "bin" / "YDWEConfig.exe"
	local command_line = string.format('"%s" -launchwar3', config_program:string())
	sys.spawn_dir(command_line, yi.get_editor_root_dir())
end

-- ʾһα
local function show_last_error()
	local jasshelper_path = yi.get_editor_root_dir() / "plugin" / "jasshelper" / "jasshelper.exe"
	local command_line = string.format('"%s" --showerrors', jasshelper_path:string())
	sys.spawn_dir(command_line, yi.get_editor_root_dir())
end

-- ʾJassHelper汾
local function show_jasshelper_version()
	local jasshelper_path = yi.get_editor_root_dir() / "plugin" / "jasshelper" / "jasshelper.exe"
	local command_line = string.format('"%s" --about', jasshelper_path:string())
	sys.spawn_dir(command_line, yi.get_editor_root_dir())
end

-- ʾcJass汾
local function show_cjass_version()
	local cjass_path = yi.get_editor_root_dir() / "plugin" / "AdicHelper" / "AdicHelper.exe"
	local command_line = cjass_path:string()
	sys.spawn_dir(command_line, yi.get_editor_root_dir())
end

-- 򿪹
local function open_offical_site()
	sys.shell_execute("http://www.ydwe.net")
end

-- WEļ
local function file_export()
	-- 򿪶Իû
	local ok, file_path_string = gui.prompt_for_input(
		main_window_handle, 																		-- ھ
		_("Export file"),														-- 
		_("Please enter the file path to export. Currently you can export only one file each time"),																				-- ʾ
		"",																		-- ı༭ʼ
		_("OK"),																-- ȷťı
		_("Cancel")																-- ȡ"ťı
	)

	if ok then
		if yi.native_generic_file_exists(file_path_string) then
			-- ѡ񱣴ļԻ
			local ok, file = gui.choose_save_file(
				main_window_handle, 														-- HWND
				"*.*\0*.*\0", 											-- Filter
				fs.path(file_path_string):filename():string(),					-- Initial file name
				nil, 													-- Initial Dir
				_("Save file")											-- Title
			)
			if ok then
				-- ѹļ
				yi.native_generic_extract_file(fs.path(file), file_path_string)
			end
		else
			sys.message_dialog(
				main_window_handle,
				_("The file you have entered does not exist."),
				_("YDWE"),
				bit.bor(ydwelua.MB_ICONERROR, ydwelua.MB_OK)
			)
		end
	end
end

-- ת
local function encoding_conversion()
	local str = sys.get_clipboard_text()
	if str then
		str = __(str)
		if str then sys.set_clipboard_text(str) else iconv_utf8_to_locale:reset() end
	end
end


-- Lua
local function lua_test()
	-- 򿪶Իû
	local ok, script_string = gui.prompt_for_input(
		main_window_handle, 													-- ھ
		_("Lua Test"),															-- 
		_("Please enter the lua script to execute"),							-- ʾ
		"",																		-- ı༭ʼ
		_("OK"),																-- ȷťı
		_("Cancel")																-- ȡ"ťı
	)

	if ok then
		log.trace("Execute code: " .. script_string)
		local code = loadstring(script_string)
		if code then
			local ok, result = pcall(code)
			if ok then
				log.trace("Code execution OK. Result: " .. tostring(result))
			else
				sys.message_dialog(
					main_window_handle,
					_("Error occured when executing code: ") .. tostring(result),
					_("YDWE"),
					bit.bor(ydwelua.MB_ICONERROR, ydwelua.MB_OK)
				)
				log.warn("Code execution failed. Error: " .. tostring(result))
			end
		else
			sys.message_dialog(
				main_window_handle,
				_("There are syntax errors in your code."),
				_("YDWE"),
				bit.bor(ydwelua.MB_ICONERROR, ydwelua.MB_OK)
			)
			log.warn("Syntax error found in the code.")
		end
	end
end


-- ˵ID
local YDWE_MENU_ID_BASE = 48886
-- ò˵ID
local YDWE_MENU_ID_CONFIG = YDWE_MENU_ID_BASE
-- Ϣ˵ID
local YDWE_MENU_ID_COMPILE_INFO = YDWE_MENU_ID_BASE + 1
-- ʾJassHelper汾˵ID
local YDWE_MENU_ID_SHOW_JASSHELPER_VERSION = YDWE_MENU_ID_BASE + 2
-- ʾcJass汾˵ID
local YDWE_MENU_ID_SHOW_CJASS_VERSION = YDWE_MENU_ID_BASE + 3
-- 򿪹˵ID
local YDWE_MENU_ID_OFFICIAL_SITE = YDWE_MENU_ID_BASE + 4
-- ļ˵ID
local YDWE_MENU_ID_FILE_EXPORT = YDWE_MENU_ID_BASE + 5
-- ת˵ID
local YDWE_MENU_ID_ENCODING_CONVERSION = YDWE_MENU_ID_BASE + 6
-- лϢʾ˵ID
local YDWE_MENU_ID_SHOW_CREDIT = YDWE_MENU_ID_BASE + 7
-- LuaԲ˵ID
local YDWE_MENU_ID_LUA_TEST = YDWE_MENU_ID_BASE + 8

local YDWE_MENU_ID_WARCRAFT3 = YDWE_MENU_ID_BASE + 9

-- ʼ˵
-- event_data - ¼tableֵ
--	main_window_handle - ڵhandle
--	main_menu_handle - ˵handle
-- ֵһɷ0
function on_menuinit(event_data)
	log.debug("********************* on menuinit start *********************")

	-- һTile Limit Breaker
	if plugin.loaders['YDTileLimitBreaker'] and plugin.loaders['YDTileLimitBreaker'].start then
		plugin.loaders['YDTileLimitBreaker'].start()
	end

	-- ȴ²˵
	ydwe_menu_handle = gui.create_menu()

	-- ӵ˵ĩβ
	gui.append_menu(event_data.main_menu_handle, bit.bor(ydwelua.MF_STRING, ydwelua.MF_POPUP), mem.pointer_to_number(ydwe_menu_handle), _("&YDWE"))

	-- Ӳ˵
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_CONFIG, _("YDWE &Config"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_WARCRAFT3, _("Launch &Warcraft3"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_COMPILE_INFO, _("Show las&t compile result"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_SHOW_JASSHELPER_VERSION, _("Show J&assHelper version"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_SHOW_CJASS_VERSION, _("Show c&Jass version"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_OFFICIAL_SITE, _("Launch YDWE &official website"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_FILE_EXPORT, _("&Export WE file"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_ENCODING_CONVERSION, _("UTF-8 to &native"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_LUA_TEST, _("&Lua Test"))
	gui.append_menu(ydwe_menu_handle, ydwelua.MF_STRING, YDWE_MENU_ID_SHOW_CREDIT, _("Cre&dits"))

	-- ˢ²˵
	gui.draw_menu_bar(event_data.main_window_handle)

	main_window_handle = event_data.main_window_handle

	log.debug("********************* on menuinit end *********************")

	return 0
end

-- WEĴڹյϢʱִ
-- event_data - ¼tableֵ
--	window_handle, message, wparam, lparam岻
-- طǸԭںظֱӳԵϢ
function on_windowevent(event_data)
	-- ֻ˵Ϣ
	if event_data.message == ydwelua.WM_COMMAND then
		-- ˵ID16λ
		local menu_id = bit.band(event_data.wparam, 0xFFFF)

		-- IDжϲ
		if menu_id == YDWE_MENU_ID_CONFIG then
			launch_config()
		elseif menu_id == YDWE_MENU_ID_COMPILE_INFO then
			show_last_error()
		elseif menu_id == YDWE_MENU_ID_SHOW_JASSHELPER_VERSION then
			show_jasshelper_version()
		elseif menu_id == YDWE_MENU_ID_SHOW_CJASS_VERSION then
			show_cjass_version()
		elseif menu_id == YDWE_MENU_ID_OFFICIAL_SITE then
			open_offical_site()
		elseif menu_id == YDWE_MENU_ID_FILE_EXPORT then
			file_export()
		elseif menu_id == YDWE_MENU_ID_ENCODING_CONVERSION then
			encoding_conversion()
		elseif menu_id == YDWE_MENU_ID_SHOW_CREDIT then
			show_credit()
		elseif menu_id == YDWE_MENU_ID_LUA_TEST then
			lua_test()
		elseif menu_id == YDWE_MENU_ID_WARCRAFT3 then
			launch_warcraft3()
		end
	end

	return 0
end
